type input = Strng.t
type 'a result = ('a * input)option
type 'a t = input -> 'a result

val (<|>) : 'a t -> 'a t -> 'a t
val (>>) : 'a t -> 'b t -> 'b t
val (>>=) : 'a t -> ('a -> 'b t) -> 'b t
val any : char t
val between : 'a t -> 'b t -> 'c t -> 'b t
val char : char -> char t
val digit : char t
val eoi : unit t
val letter : char t
val many : 'a t -> ('a list)t
val many1 : 'a t -> ('a list)t
val noneof : string -> char t
val oneof : string -> char t
val parse : 'a t -> string -> 'a option
val return : 'a -> 'a t
val sat : (char -> bool) -> char t
val sep_by : 'a t -> 'b t -> ('b list)t
val sep_by1 : 'a t -> 'b t -> ('b list)t
val space : char t
val spaces : unit t
val string : string -> Strng.t t
val test : 'a t -> string -> 'a
